static char *cvs_id =" $Id: bm_rad.c,v 1.9 2003/09/22 09:52:05 berar Exp $ ";
/*  bm_rad : image princeton (Winview ) et autres    */
/*  jfberar   berar@esrf.fr     */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>
/*-----------------------------------------------------------*/

#include "xy_def.h"
#include "bm_def.h"
/* #include <values.h> cygwin pb*/
#ifndef MAXFLOAT
#define MAXFLOAT 1.e+35
#endif

extern char * f_name;
extern char * d_name;
extern char * g_name;
extern char * i_name;
/*-----------------------------------------------------------*/
/* used in specific external routines */
int   n_sector = 1;
float a_sector = 0.0;
float radius = 1.0;
float rad_lim = -MAXFLOAT;      /* I do not know how to set -Inf on various machine */
char *p_sector = NULL;
char *rad_x = NULL;
char *rad_y = NULL;
char *rad_dx = NULL;
char *rad_dy = NULL;
/*-----------------------------------------------------------*/
#define MAX_SECTORS 72
int   writen_lines=0;
char  rad_line[7+30*MAX_SECTORS];
int   valid_rad_line;
void  ini_rad_line(int n);
void  add_rad_line(double y, double z, double n_r);
int   end_rad_line(FILE * f_out);
/*-----------------------------------------------------------*/
void ini_transfo_coord( char *name, int axe);
void end_transfo_coord( );
double transfo_coord( int axe, double x, double y);
double density_coord( int axe, double x, double y);
/*-----------------------------------------------------------*/
extern int   cr_mode;
/*-----------------------------------------------------------*/
void use_radial()
{
    fprintf(stderr, "  radial distribution is centered by ORIGIN key\n");
    fprintf(stderr, "    and the following group of dedicated keys\n");
    fprintf(stderr, " RADIUS = radius binning\n");
    fprintf(stderr, " RAD_LIM  = low limit value in radial distribution (not set is no limit)\n");
    fprintf(stderr, " N_SECTOR  = number of angular sectors (num 0 to N_SECTOR-1)\n");
    fprintf(stderr, " A_SECTOR  = origin (degree) of the first sector\n");
    fprintf(stderr, " P_SECTOR  = if not empty, binning specifications without space\n");
    fprintf(stderr, " RAD_X   = if not empty, X geometrical transformation, RAD_Y\n");
    fprintf(stderr, " RAD_DX  = if not empty, X geometrical density related to RAD_X, RAD_DY\n");
    fprintf(stderr, "    radial distribution example, N=8,A=-22.5,P=0+4,2+6,1+3+5+7 print 3 curves\n");
    fprintf(stderr, "  if grid is corrected on the fly, specify GRID_ORIG=CONVERT to convert the origin\n");
    }
/*-----------------------------------------------------------*/
int ini_radial(char * tag, char * arg)
{   char *stdin_name = NULL;
	 if (prg_iniflt( tag, arg, "RADIUS",   &radius)) return 1; 
    if (prg_iniflt( tag, arg, "RAD_LIM",  &rad_lim)) return 1; 
    if (prg_iniint( tag, arg, "N_SECTOR", &n_sector)) return 1;
    if (prg_iniflt( tag, arg, "A_SECTOR", &a_sector)) return 1;
    if (prg_inistr( tag, arg, "P_SECTOR", &p_sector)) return 1;
    if (prg_inistr( tag, arg, "RAD_X",    &rad_x)) return 1;
    if (prg_inistr( tag, arg, "RAD_Y",    &rad_y)) return 1;
    if (prg_inistr( tag, arg, "RAD_DX",   &rad_dx)) return 1;
    if (prg_inistr( tag, arg, "RAD_DY",   &rad_dy)) return 1;
    return 0;
	 }
/*-----------------------------------------------------------*/
#ifndef M_PI
#define M_PI               3.14159265358979323846
#endif
void radial(char * name, char *path, IMAGE *img)
{   int i, j, ix, iy, n, s, dim;
    double xx, x, y, z;
    double center_x, center_y;
    float r, rmax, a, dr, w;
    double **s_r, **q_r, **n_r;
    COUNTS *val = img->data;
    FRAMES *frame = img->frame;
    double dens_x, dens_y, dens;
    FILE *f_out;
    char *c, b[200];

    if (img->data == NULL) V_ERROR("no data to write");
/*    if (name)
    else
*/    if (path) 
    {   strcpy (b, path);    
        c = strrchr(b,'/');
        if ( !c || c - b != strlen(b)-1 ) strcat(b, "/");
        }
    else b[0]=0;
    c = strrchr(img->name,'/');
    if ( c )  c++; else c = img->name;
    strcat (b, c);
    c = strrchr(b, '/');
    if ( !c ) c = b;
    c = strrchr(c, '.');
    if ( c ) *c = 0;
    if (d_name) strcat (b, "d");
    if (f_name) strcat (b, "f");
    if (g_name) strcat (b, "g");
    strcat (b, ".rad");
    
    prg_printf ("# output radial results in %s\n", b);     
    f_out = fopen(b, "w");
    center_x = ( orig_x == 0.0) ? image.x_size/2.0 : orig_x;
    center_y = ( orig_y == 0.0) ? image.y_size/2.0 : orig_y;
    if (grid_orig && strstr("CONVERT",grid_orig))
    {   double gsx, gsy;
        gsx = grid_pix_xcor(center_x, &grid_cor);
        gsy = grid_pix_ycor(center_y, &grid_cor);
        x=grid_cor_xpos(gsx,gsy,&grid_cor);
        y=grid_cor_ypos(gsx,gsy,&grid_cor);
        printf ("using grid corrected center %.3f %.3f for %.3f %.3f\n", 
               x, y, center_x, center_y);
        center_x=x;
        center_y=y;
        }
    center_x -= image.x_omin;
    center_y -= image.y_omin;
    center_x /= image.x_obind;
    center_y /= image.y_obind;
    xy_orien_pixel(&image, &center_x, &center_y, 1);
    rmax = 0;
    if ( (a=center_x*center_x + center_y*center_y) > rmax ) rmax = a;
    if ( (a=center_x*center_x + (image.y_size-center_y)*(image.y_size-center_y)) > rmax ) rmax = a;
    if ( (a=(image.x_size-center_x)*(image.x_size-center_x) + center_y*center_y) > rmax ) rmax = a;
    if ( (a=(image.x_size-center_x)*(image.x_size-center_x) + (image.y_size-center_y)*(image.y_size-center_y)) > rmax ) rmax = a;
    rmax = sqrt(rmax+1);
    if ( radius < 1 ) radius = 1;
    dim = 3 + rmax / radius;
    prg_printf ("# center %.2f %.2f -> %.2f %.2f, r_max %.2f,  dim %d\n", 
        orig_x, orig_y, center_x, center_y, rmax, dim );
    if (n_sector < 1 || n_sector > MAX_SECTORS ) n_sector = 1;
    prg_printf ("# %d sectors with origine of first sector starting at %.2f deg\n", n_sector, a_sector);
    fprintf (f_out, "# %s (%d-%d)/%d*(%d-%d)/%d  (%s)\n\
# center %.2f %.2f -> %.2f %.2f, r_max %.2f\n\
# %d sectors with origine at %.2f deg\n", b, 
	image.x_omin, image.x_omax, image.x_obind, 
	image.y_omin, image.y_omax, image.y_obind, i_name ? i_name:"",
	orig_x, orig_y, center_x, center_y, rmax,  n_sector, a_sector);
    
    if ( rad_x) 
    {  ini_transfo_coord(rad_x, 0);
       center_x = transfo_coord(0, center_x, center_y);
       }
    if ( rad_dx)  ini_transfo_coord(rad_dx, 2);
    if ( rad_y) 
    {  ini_transfo_coord(rad_y, 1);
       center_y = transfo_coord(1, center_x, center_y);
       }
    if ( rad_dy)  ini_transfo_coord(rad_dy, 3);
    s_r = (double**) malloc(n_sector*sizeof(double*));
    q_r = (double**) malloc(n_sector*sizeof(double*));
    n_r = (double**) malloc(n_sector*sizeof(double*));
    dens_x = 1.0;
    dens_y = 1.0;
    for (s = 0; s < n_sector; s++)
    {   s_r[s] = (double*) malloc(dim*sizeof(double));
        q_r[s] = (double*) malloc(dim*sizeof(double));
        n_r[s] = (double*) malloc(dim*sizeof(double));
        memset(s_r[s], 0, dim*sizeof(double));
        memset(q_r[s], 0, dim*sizeof(double));
        memset(n_r[s], 0, dim*sizeof(double));
        }
    for (i = 0; i <image.size; i++)
    {    if ( frame[i]==0 ) continue;
         ix = i % image.x_size;
         iy = i / image.x_size;
         if ( rad_dx)  dens_x = transfo_coord(2, ix, iy);
         if ( rad_dy)  dens_y = transfo_coord(3, ix, iy);
         if ( rad_x) x = transfo_coord(0, ix, iy) - center_x+0.5;
         else x = ix-center_x+0.5;
         if ( rad_y) y = transfo_coord(1, ix, iy) - center_y+0.5;
         else y = iy-center_y+0.5;
         r = sqrt(x*x+y*y);
         a = 180*atan2(y, x)/ M_PI;
         n = (r + 0.5) / radius;
         if ( n >= dim ) continue;
         dr = r - n * radius;
         s= n_sector * ( a + 360.0 - a_sector ) / 360.0;
         s %= n_sector;
         while ( s < 0 ) s+= n_sector;
         dens= dens_x * dens_y;
         if (dr >  0.5 *( radius - 1.0 ) )
         {  w = 1.0 - dr;
            s_r[s][n] += w * val[i];
            q_r[s][n] += w * val[i] * val[i];
            n_r[s][n] += w * dens;
            s_r[s][n+1] += (1-w) * val[i];
            q_r[s][n+1] += (1-w) * val[i] * val[i];
            n_r[s][n+1] += (1-w) * dens;
            }
         else if (dr < 0.5 *(1.0- radius ))
         {  w = 1.0 + dr;
            s_r[s][n] += w * val[i];
            q_r[s][n] += w * val[i] * val[i];
            n_r[s][n] += w * dens;
            s_r[s][n-1] += (1-w) * val[i];
            q_r[s][n-1] += (1-w) * val[i] * val[i];
            n_r[s][n-1] += (1-w) * dens;
            }
         else
         {  s_r[s][n] += val[i];
            q_r[s][n] += val[i] * val[i];
            n_r[s][n] += dens;
            }
        }
    if (p_sector==NULL) 
	 {  fprintf (f_out, "#   r      s/n       e(s/n)   n  ...%c\n", cr_mode==0?' ':'\r');
       for (n = 0; n < dim; n++)
       {  ini_rad_line(n);
          for (s = 0; s < n_sector; s++)
          {   x = n_r[s][n];
              if (x < 0.1) x = 1;
              y = s_r[s][n] / x;
              if (  y < rad_lim ) y = rad_lim;
				  z = (q_r[s][n] - x * y *y) / (x - 0.999999 );
              if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
              add_rad_line(y, z, n_r[s][n]);
				  }
           writen_lines+=end_rad_line(f_out);
           }
        prg_printf ("# %d * %d data writen in %s, %d valid lines\n", dim, n_sector, b, writen_lines);
		  } else
	  {  char *d;
	     int e, b_sector, u, us, *used_sector;
		  used_sector = (int *) malloc(n_sector*sizeof(int));
		  fprintf (f_out, "# print sectors binned according : '%s'%c\n", p_sector, cr_mode==0?' ':'\r');
		  fflush(f_out);
        if (used_sector==NULL)
		  {   fprintf(stderr, "unable to allocate memory for sectors definition!!\n");
		      exit(3);
				}
		  for (i=0;i<n_sector;i++) used_sector[i]=0;		
		  b_sector = us = 0;
		  e = 0;
		  d = p_sector;
		  while (*d)
		  {  while ( sscanf(d,"%d", &u) == 1)
			  {  if ( u >= n_sector )	
			     {   printf (" invalid sector %d ( >= %d ), skipped!\n", u, n_sector );
				      fprintf (f_out," invalid sector %d ( >= %d ), skipped!\n", u, n_sector );
                  exit(3);
                  }
			     if ( used_sector[u] )	
			     {   printf (" sector %d used more than one times!\n", u);
				      fprintf (f_out," sector %d used more than onc times!\n", u);
				      exit(3);
                  }
			     e++;
				  used_sector[u] = b_sector+1;
				  us++;
				  if (*d=='+') d++;
				  while (isdigit(*d)) d++;
				  if (*d==','||*d==0) break;
				  }
		      e=0;
				if (*d==',') d++;
				b_sector++;
				}
        fprintf(f_out, "# %d used sectors (of %d) are binned in %d group : ", us, n_sector, b_sector);
		  for (i=0;i<b_sector;i++) 		
		  {  fprintf(f_out, " %d (",i );
		  	  for (j=0;j<n_sector;j++)  if (used_sector[j] == i+1) 	fprintf(f_out, " %d", j);
		  	  fprintf(f_out, ") %s", (i+1==b_sector)?"\n":" , " );
			  }
	     fprintf (f_out, "#   r       s/n       e(s/n)    n  ...%c\n", cr_mode==0?' ':'\r');
		  fflush(f_out);
        for (n = 0; n < dim; n++)
        {   ini_rad_line(n);
		      for (j = 0; j < b_sector; j++)
            {   xx = y = z = 0;
				    for (s = 0; s < n_sector; s++)
                {  if (used_sector[s] != j+1 ) continue;
					    xx += n_r[s][n];
						 y += s_r[s][n];
						 z += q_r[s][n];
						 }
                x = (xx < 0.1) ? 1 : xx;
                y /= x;
                if (  y < rad_lim ) y = rad_lim;
                z = (z - x * y *y) / (x - 0.99999 );
                if ( z > 0 && x > 2.0) z = sqrt(z / x) ; else z =-1.0;
                add_rad_line(y, z, xx);
                }
            writen_lines+=end_rad_line(f_out);
				
            }
		  free(used_sector);	
        prg_printf ("# %d * %d data writen in %s, %d valid lines\n", dim, b_sector, b, writen_lines);
	     }	  
    fclose (f_out);
    if ( rad_x ||  rad_y) end_transfo_coord();
    for (s = 0; s < n_sector; s++)
    {   free( s_r[s]); 
        free( q_r[s]);
        free( n_r[s]);
        }
    free( s_r );
    free( q_r );
    free( n_r );
    }
/*-----------------------------------------------------------*/
void ini_rad_line(int n)
{   sprintf (rad_line, " %4d", n);
    valid_rad_line=0;
	 }
/*-----------------------------------------------------------*/
void add_rad_line(double y, double z, double n_r)
{   char *c;
    c=rad_line + strlen(rad_line);
    sprintf (c, "  %10.2lf %8.2lf %6.1lf  ", y, z, n_r);
    if ( y > 0 || z > 0 ) valid_rad_line++;
	 }
/*-----------------------------------------------------------*/
int end_rad_line(FILE * f_out)
{   if (valid_rad_line)
    {  fprintf (f_out, "%s%c\n", rad_line, cr_mode==0?' ':'\r');
	    return 1;
		 }
	 return 0;	 
	 }
/*-----------------------------------------------------------*/

